## mingw-w64-libpsml-2.1.0-1.src.tar.zst

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.17)

list(APPEND CMAKE_MESSAGE_CONTEXT "libpsml")
project(
  "libpsml"
  LANGUAGES "Fortran"
  VERSION "2.1.0"
  DESCRIPTION "Library to process PSML pseudopotential files"
)

list(PREPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/config/cmake")

# Set build type as CMake does not provide defaults
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(
    CMAKE_BUILD_TYPE "RelWithDebInfo"
    CACHE STRING "Build type to be used."
    FORCE
  )
  message(
    STATUS
    "Setting build type to '${CMAKE_BUILD_TYPE}' as none was specified."
  )
endif()

option(BUILD_SHARED_LIBS "Whether the libraries built should be shared" FALSE)

if (NOT TARGET "xmlf90::xmlf90")
   message(STATUS "   --- libpsml needs target xmlf90::xmlf90")
   find_package(Customxmlf90)
endif()

# Avoid "liblibpsml.a" names...
set(LIBRARY_OUTPUT_NAME "psml")

# Collect source of the project
set(srcs)
add_subdirectory("src")

add_library("${PROJECT_NAME}-lib" "${srcs}")

#-------------
#  These are records of features that could be checked programmatically when
#  configuring clients if libpsml is used as a pre-compiled library, but
#  not if the libpsml source is compiled by the client.
#
set(LIBPSML_HAS_ERROR_PROCEDURE_POINTER TRUE CACHE BOOL "libpsml uses a procedure pointer for error handling")
set(LIBPSML_READER_HAS_STAT TRUE CACHE BOOL "psml_reader has an optional 'stat' return argument")
#-------------

set_target_properties(
  "${PROJECT_NAME}-lib"
  PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE
  OUTPUT_NAME "${LIBRARY_OUTPUT_NAME}"
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  Fortran_MODULE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/include"
)

# Check for xmlf90 feature

include(check_xmlf90_stat)
if (XMLF90_PARSE_HAS_STAT)
 target_compile_definitions("${PROJECT_NAME}-lib" PRIVATE XMLF90_PARSE_HAS_STAT)
endif()

target_link_libraries("${PROJECT_NAME}-lib" PUBLIC xmlf90::xmlf90)

### -----
# Install

# Follow GNU conventions for installing directories
include(GNUInstallDirs)

set(module-dir
  "${PROJECT_NAME}/${CMAKE_Fortran_COMPILER_ID}-${CMAKE_Fortran_COMPILER_VERSION}"
)

target_include_directories(
  "${PROJECT_NAME}-lib"
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}>
)

# Export targets for other projects
add_library("${PROJECT_NAME}" INTERFACE)
target_link_libraries("${PROJECT_NAME}" INTERFACE "${PROJECT_NAME}-lib")
install(
  TARGETS
  "${PROJECT_NAME}"
  "${PROJECT_NAME}-lib"
  EXPORT
  "${PROJECT_NAME}-targets"
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
)
install(
  EXPORT
  "${PROJECT_NAME}-targets"
  NAMESPACE
  "${PROJECT_NAME}::"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
install(
  DIRECTORY
  "${CMAKE_CURRENT_BINARY_DIR}/include/"
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}"
)
# Package license files
install(
  FILES
  "COPYING"
  DESTINATION "${CMAKE_INSTALL_DATADIR}/licenses/${PROJECT_NAME}"
)

include(CMakePackageConfigHelpers)
configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/config/template.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
#
# Use "AnyNewerVersion" but recommend checking for new features
# (i.e. procedure pointers) at client's configuration time.
# In this way we can request, say, a minimum version of 1.1.12, and
# still be able to use 2.X if found.
#
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  VERSION "${PROJECT_VERSION}"
  COMPATIBILITY AnyNewerVersion
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

#
# Copy also search helpers
#
install(
  DIRECTORY
  "${PROJECT_SOURCE_DIR}/config/cmake/"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/config/template.pkgconf"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  @ONLY
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

# add the testsuite
include(CTest)
add_subdirectory("examples")

list(POP_FRONT CMAKE_MODULE_PATH)
list(POP_FRONT CMAKE_MESSAGE_CONTEXT)

=== examples/CMakeLists.txt ===
#
# To avoid complaints from Ninja
#
add_library(lib-getopts m_getopts.f90)
target_link_libraries(lib-getopts
  ${PROJECT_NAME}-lib
)

set(top_src_dir "${PROJECT_SOURCE_DIR}/src")

add_executable(
  getz
  getz.F90
  custom_psml_die.F90
)
add_executable(
  getz_stat
  getz_stat.F90
  custom_psml_die.F90
)
add_executable(
  show_psml
  show_psml.F90
  custom_psml_die.F90
  interpolate_drh.f90
)
target_link_libraries(getz
  PRIVATE
  ${PROJECT_NAME}-lib
  lib-getopts
)
target_link_libraries(getz_stat
  PRIVATE
  ${PROJECT_NAME}-lib
  lib-getopts
)
target_link_libraries(show_psml
  PRIVATE
  ${PROJECT_NAME}-lib
  lib-getopts
)

file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests")
file(COPY 80_Hg.psml DESTINATION "${PROJECT_BINARY_DIR}/install_tests")
file(COPY 29_Cu_m.psml DESTINATION "${PROJECT_BINARY_DIR}/install_tests")
file(COPY bad.psml DESTINATION "${PROJECT_BINARY_DIR}/install_tests")
file(COPY mgga.psml DESTINATION "${PROJECT_BINARY_DIR}/install_tests")

add_test(  NAME    libpsml_getz
           COMMAND getz 80_Hg.psml
	   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests"
	)
set_property (TEST libpsml_getz
              PROPERTY PASS_REGULAR_EXPRESSION "80")

# This second test involves a call to the custom error handler

add_test(  NAME    libpsml_getz_die
           COMMAND getz NonExistentFile
	   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests"
	)

set_property (TEST libpsml_getz_die
              PROPERTY PASS_REGULAR_EXPRESSION "Custom psml_die")

#-- Tests of 'stat' return variable

add_test(  NAME    libpsml_getz_stat_non_existent
           COMMAND getz_stat NonExistentFile
	   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests"
	)

set_property (TEST libpsml_getz_stat_non_existent
              PROPERTY PASS_REGULAR_EXPRESSION "PSML reader error")

#-- Test of a malformed .psml file. The error will be caught by xmlf90,
#   which would either set a 'stat' return variable or stop the program.

add_test(  NAME    libpsml_getz_stat_parsing
           COMMAND getz_stat bad.psml
	   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests"
	)

if(XMLF90_PARSE_HAS_STAT)
    set_property (TEST libpsml_getz_stat_parsing
              PROPERTY PASS_REGULAR_EXPRESSION "PSML reader error")
else()
    # In this case the psml reader will not get a status flag,
    # and the program will stop after having printed the
    # standard xmlf90 error message
    
    set_property (TEST libpsml_getz_stat_parsing
              PROPERTY PASS_REGULAR_EXPRESSION "Nesting error: End tag: psml")
endif()

#--

add_test(  NAME    libpsml_show
           COMMAND show_psml -p 80_Hg.psml
	   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests"
	)
set_property (TEST libpsml_show
              PROPERTY PASS_REGULAR_EXPRESSION
               "scalar_relativistic    3   2   -0.291436")

#--

add_test(  NAME    libpsml_mgga
           COMMAND show_psml -p mgga.psml
	   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests"
	)
set_property (TEST libpsml_mgga
              PROPERTY PASS_REGULAR_EXPRESSION
               "model-tau-form : MGGA function")

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=libpsml
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.1.0
pkgrel=1
pkgdesc="Library to process PSML pseudopotential files. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://gitlab.com/siesta-project/libraries/libpsml'
msys2_references=(
  'aur: libpsml'
)
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-xmlf90"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran"))
makedepends=("${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://gitlab.com/siesta-project/libraries/libpsml/-/archive/${pkgver}/${_realname}-${pkgver}.tar.bz2"
        "001-fix-install-dll.patch")
sha256sums=('e531270ae6daeabca713405b7e4b69ddfe8c552aca23d367cee19adcfbbb8d05'
            'ce532469cfb28d55c2b65fbb245b2a17150c0fde71958ef40bebe1309bf960e1')

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  patch -Np1 -i "${srcdir}"/001-fix-install-dll.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  sed -s "s|${PREFIX_WIN}|\$\{PACKAGE_PREFIX_DIR\}|g" -i "${pkgdir}"${MINGW_PREFIX}/lib/cmake/libpsml/libpsml-config.cmake
}
